Index: uspace/lib/ui/test/wdecor.c
===================================================================
--- uspace/lib/ui/test/wdecor.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/wdecor.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,4 +34,5 @@
 #include <ui/pbutton.h>
 #include <ui/resource.h>
+#include <ui/ui.h>
 #include <ui/wdecor.h>
 #include "../private/wdecor.h"
@@ -62,11 +63,26 @@
 };
 
+static void test_wdecor_sysmenu_open(ui_wdecor_t *, void *, sysarg_t);
+static void test_wdecor_sysmenu_left(ui_wdecor_t *, void *, sysarg_t);
+static void test_wdecor_sysmenu_right(ui_wdecor_t *, void *, sysarg_t);
+static void test_wdecor_sysmenu_accel(ui_wdecor_t *, void *, char32_t,
+    sysarg_t);
+static void test_wdecor_minimize(ui_wdecor_t *, void *);
+static void test_wdecor_maximize(ui_wdecor_t *, void *);
+static void test_wdecor_unmaximize(ui_wdecor_t *, void *);
 static void test_wdecor_close(ui_wdecor_t *, void *);
-static void test_wdecor_move(ui_wdecor_t *, void *, gfx_coord2_t *);
+static void test_wdecor_move(ui_wdecor_t *, void *, gfx_coord2_t *, sysarg_t);
 static void test_wdecor_resize(ui_wdecor_t *, void *, ui_wdecor_rsztype_t,
-    gfx_coord2_t *);
+    gfx_coord2_t *, sysarg_t);
 static void test_wdecor_set_cursor(ui_wdecor_t *, void *, ui_stock_cursor_t);
 
 static ui_wdecor_cb_t test_wdecor_cb = {
+	.sysmenu_open = test_wdecor_sysmenu_open,
+	.sysmenu_left = test_wdecor_sysmenu_left,
+	.sysmenu_right = test_wdecor_sysmenu_right,
+	.sysmenu_accel = test_wdecor_sysmenu_accel,
+	.minimize = test_wdecor_minimize,
+	.maximize = test_wdecor_maximize,
+	.unmaximize = test_wdecor_unmaximize,
 	.close = test_wdecor_close,
 	.move = test_wdecor_move,
@@ -96,7 +112,17 @@
 
 typedef struct {
+	bool sysmenu_open;
+	bool sysmenu_left;
+	bool sysmenu_right;
+	bool sysmenu_accel;
+	bool minimize;
+	bool maximize;
+	bool unmaximize;
 	bool close;
 	bool move;
 	gfx_coord2_t pos;
+	sysarg_t pos_id;
+	sysarg_t idev_id;
+	char32_t accel;
 	bool resize;
 	ui_wdecor_rsztype_t rsztype;
@@ -105,5 +131,5 @@
 } test_cb_resp_t;
 
-/** Create and destroy button */
+/** Create and destroy window decoration */
 PCUT_TEST(create_destroy)
 {
@@ -127,9 +153,20 @@
 PCUT_TEST(set_rect)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -146,4 +183,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -168,6 +209,26 @@
 }
 
-/** Paint button */
-PCUT_TEST(paint)
+/** Set window decoration maximized sets internal field */
+PCUT_TEST(set_maximized)
+{
+	ui_wdecor_t *wdecor;
+	errno_t rc;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(wdecor->active);
+
+	ui_wdecor_set_maximized(wdecor, false);
+	PCUT_ASSERT_FALSE(wdecor->maximized);
+
+	ui_wdecor_set_maximized(wdecor, true);
+	PCUT_ASSERT_TRUE(wdecor->maximized);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Setting system menu handle as active/inactive */
+PCUT_TEST(sysmenu_hdl_set_active)
 {
 	errno_t rc;
@@ -185,5 +246,70 @@
 	PCUT_ASSERT_NOT_NULL(resource);
 
-	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(wdecor->sysmenu_hdl_active);
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, true);
+	PCUT_ASSERT_TRUE(wdecor->sysmenu_hdl_active);
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, false);
+	PCUT_ASSERT_FALSE(wdecor->sysmenu_hdl_active);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint system menu handle */
+PCUT_TEST(sysmenu_hdl_paint)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+	ui_wdecor_geom_t geom;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wdecor_get_geom(wdecor, &geom);
+	rc = ui_wdecor_sysmenu_hdl_paint(wdecor, &geom.sysmenu_hdl_rect);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Paint window decoration */
+PCUT_TEST(paint)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -196,4 +322,195 @@
 	rc = gfx_context_delete(gc);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Test ui_wdecor_sysmenu_open() */
+PCUT_TEST(sysmenu_open)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Sysmenu open callback with no callbacks set */
+	ui_wdecor_sysmenu_open(wdecor, 42);
+
+	/* Sysmenu open callback with sysmenu callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_sysmenu_open(wdecor, 42);
+
+	/* Sysmenu open callback with real callback set */
+	resp.sysmenu_open = false;
+	resp.idev_id = 0;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_sysmenu_open(wdecor, 42);
+	PCUT_ASSERT_TRUE(resp.sysmenu_open);
+	PCUT_ASSERT_INT_EQUALS(42, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_sysmenu_left() */
+PCUT_TEST(sysmenu_left)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Sysmenu left callback with no callbacks set */
+	ui_wdecor_sysmenu_left(wdecor, 42);
+
+	/* Sysmenu left callback with sysmenu callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_sysmenu_left(wdecor, 42);
+
+	/* Sysmenu left callback with real callback set */
+	resp.sysmenu_left = false;
+	resp.idev_id = 0;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_sysmenu_left(wdecor, 42);
+	PCUT_ASSERT_TRUE(resp.sysmenu_left);
+	PCUT_ASSERT_INT_EQUALS(42, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_sysmenu_right() */
+PCUT_TEST(sysmenu_right)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Sysmenu right callback with no callbacks set */
+	ui_wdecor_sysmenu_right(wdecor, 42);
+
+	/* Sysmenu right callback with sysmenu callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_sysmenu_right(wdecor, 42);
+
+	/* Sysmenu right callback with real callback set */
+	resp.sysmenu_right = false;
+	resp.idev_id = 0;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_sysmenu_right(wdecor, 42);
+	PCUT_ASSERT_TRUE(resp.sysmenu_right);
+	PCUT_ASSERT_INT_EQUALS(42, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_sysmenu_accel() */
+PCUT_TEST(sysmenu_accel)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Sysmenu accelerator callback with no callbacks set */
+	ui_wdecor_sysmenu_accel(wdecor, 'a', 42);
+
+	/* Sysmenu accelerator callback with sysmenu callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_sysmenu_accel(wdecor, 'a', 42);
+
+	/* Sysmenu accelerator callback with real callback set */
+	resp.sysmenu_accel = false;
+	resp.idev_id = 0;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_sysmenu_accel(wdecor, 'a', 42);
+	PCUT_ASSERT_TRUE(resp.sysmenu_accel);
+	PCUT_ASSERT_INT_EQUALS('a', resp.accel);
+	PCUT_ASSERT_INT_EQUALS(42, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_minimize() */
+PCUT_TEST(minimize)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Minimize callback with no callbacks set */
+	ui_wdecor_minimize(wdecor);
+
+	/* Minimize callback with minimize callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_minimize(wdecor);
+
+	/* Minimize callback with real callback set */
+	resp.minimize = false;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_minimize(wdecor);
+	PCUT_ASSERT_TRUE(resp.minimize);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_maximize() */
+PCUT_TEST(maximize)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Maximize callback with no callbacks set */
+	ui_wdecor_maximize(wdecor);
+
+	/* Maxmimize callback with maximize callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_maximize(wdecor);
+
+	/* Maximize callback with real callback set */
+	resp.maximize = false;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_maximize(wdecor);
+	PCUT_ASSERT_TRUE(resp.maximize);
+
+	ui_wdecor_destroy(wdecor);
+}
+
+/** Test ui_wdecor_unmaximize() */
+PCUT_TEST(unmaximize)
+{
+	errno_t rc;
+	ui_wdecor_t *wdecor;
+	test_cb_resp_t resp;
+
+	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Unmaximize callback with no callbacks set */
+	ui_wdecor_unmaximize(wdecor);
+
+	/* Unmaximize callback with unmaximize callback not implemented */
+	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
+	ui_wdecor_unmaximize(wdecor);
+
+	/* Unmaximize callback with real callback set */
+	resp.unmaximize = false;
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
+	ui_wdecor_unmaximize(wdecor);
+	PCUT_ASSERT_TRUE(resp.unmaximize);
+
+	ui_wdecor_destroy(wdecor);
 }
 
@@ -231,4 +548,5 @@
 	test_cb_resp_t resp;
 	gfx_coord2_t pos;
+	sysarg_t pos_id;
 
 	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
@@ -237,11 +555,12 @@
 	pos.x = 3;
 	pos.y = 4;
+	pos_id = 5;
 
 	/* Move callback with no callbacks set */
-	ui_wdecor_move(wdecor, &pos);
+	ui_wdecor_move(wdecor, &pos, pos_id);
 
 	/* Move callback with move callback not implemented */
 	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
-	ui_wdecor_move(wdecor, &pos);
+	ui_wdecor_move(wdecor, &pos, pos_id);
 
 	/* Move callback with real callback set */
@@ -249,9 +568,11 @@
 	resp.pos.x = 0;
 	resp.pos.y = 0;
+	resp.pos_id = 0;
 	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
-	ui_wdecor_move(wdecor, &pos);
+	ui_wdecor_move(wdecor, &pos, pos_id);
 	PCUT_ASSERT_TRUE(resp.move);
 	PCUT_ASSERT_INT_EQUALS(pos.x, resp.pos.x);
 	PCUT_ASSERT_INT_EQUALS(pos.y, resp.pos.y);
+	PCUT_ASSERT_INT_EQUALS(pos_id, resp.pos_id);
 
 	ui_wdecor_destroy(wdecor);
@@ -266,4 +587,5 @@
 	ui_wdecor_rsztype_t rsztype;
 	gfx_coord2_t pos;
+	sysarg_t pos_id;
 
 	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
@@ -273,11 +595,12 @@
 	pos.x = 3;
 	pos.y = 4;
+	pos_id = 5;
 
 	/* Resize callback with no callbacks set */
-	ui_wdecor_resize(wdecor, rsztype, &pos);
+	ui_wdecor_resize(wdecor, rsztype, &pos, pos_id);
 
 	/* Resize callback with move callback not implemented */
 	ui_wdecor_set_cb(wdecor, &dummy_wdecor_cb, NULL);
-	ui_wdecor_resize(wdecor, rsztype, &pos);
+	ui_wdecor_resize(wdecor, rsztype, &pos, pos_id);
 
 	/* Resize callback with real callback set */
@@ -287,9 +610,10 @@
 	resp.pos.y = 0;
 	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, &resp);
-	ui_wdecor_resize(wdecor, rsztype, &pos);
+	ui_wdecor_resize(wdecor, rsztype, &pos, pos_id);
 	PCUT_ASSERT_TRUE(resp.resize);
 	PCUT_ASSERT_INT_EQUALS(rsztype, resp.rsztype);
 	PCUT_ASSERT_INT_EQUALS(pos.x, resp.pos.x);
 	PCUT_ASSERT_INT_EQUALS(pos.y, resp.pos.y);
+	PCUT_ASSERT_INT_EQUALS(pos_id, resp.pos_id);
 
 	ui_wdecor_destroy(wdecor);
@@ -330,4 +654,7 @@
 PCUT_TEST(close_btn_clicked)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -335,5 +662,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -353,4 +688,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -407,14 +746,19 @@
 }
 
-/** ui_wdecor_get_geom() with ui_wds_none produces the correct geometry */
-PCUT_TEST(get_geom_none)
-{
+/** Pressing F10 generates sysmenu event.
+ *
+ * Note that in a window with menu bar the menu bar would claim F10
+ * so it would never be delivered to window decoration.
+ */
+PCUT_TEST(kbd_f10_sysmenu)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	kbd_event_t event;
 	gfx_context_t *gc = NULL;
 	test_gc_t tgc;
+	test_cb_resp_t resp;
 	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
-	gfx_rect_t rect;
-	ui_wdecor_geom_t geom;
-	errno_t rc;
 
 	memset(&tgc, 0, sizeof(tgc));
@@ -426,5 +770,5 @@
 	PCUT_ASSERT_NOT_NULL(resource);
 
-	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -435,4 +779,263 @@
 
 	ui_wdecor_set_rect(wdecor, &rect);
+
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, (void *) &resp);
+
+	resp.sysmenu_open = false;
+
+	event.type = KEY_PRESS;
+	event.mods = 0;
+	event.key = KC_F10;
+	event.kbd_id = 42;
+	ui_wdecor_kbd_event(wdecor, &event);
+
+	PCUT_ASSERT_TRUE(resp.sysmenu_open);
+	PCUT_ASSERT_INT_EQUALS(event.kbd_id, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Down key with active sysmenu handle generates sysmenu open event */
+PCUT_TEST(kbd_down_sysmenu)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	kbd_event_t event;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	test_cb_resp_t resp;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 100;
+	rect.p1.y = 200;
+
+	ui_wdecor_set_rect(wdecor, &rect);
+
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, (void *) &resp);
+
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, true);
+
+	resp.sysmenu_open = false;
+
+	event.type = KEY_PRESS;
+	event.mods = 0;
+	event.key = KC_DOWN;
+	event.kbd_id = 42;
+	ui_wdecor_kbd_event(wdecor, &event);
+
+	PCUT_ASSERT_TRUE(resp.sysmenu_open);
+	PCUT_ASSERT_INT_EQUALS(event.kbd_id, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Left key with active sysmenu handle generates sysmenu left event */
+PCUT_TEST(kbd_left_sysmenu)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	kbd_event_t event;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	test_cb_resp_t resp;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 100;
+	rect.p1.y = 200;
+
+	ui_wdecor_set_rect(wdecor, &rect);
+
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, (void *) &resp);
+
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, true);
+
+	resp.sysmenu_left = false;
+
+	event.type = KEY_PRESS;
+	event.mods = 0;
+	event.key = KC_LEFT;
+	event.kbd_id = 42;
+	ui_wdecor_kbd_event(wdecor, &event);
+
+	PCUT_ASSERT_TRUE(resp.sysmenu_left);
+	PCUT_ASSERT_INT_EQUALS(event.kbd_id, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Right key with active sysmenu handle generates sysmenu right event */
+PCUT_TEST(kbd_right_sysmenu)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	kbd_event_t event;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	test_cb_resp_t resp;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 100;
+	rect.p1.y = 200;
+
+	ui_wdecor_set_rect(wdecor, &rect);
+
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, (void *) &resp);
+
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, true);
+
+	resp.sysmenu_right = false;
+
+	event.type = KEY_PRESS;
+	event.mods = 0;
+	event.key = KC_RIGHT;
+	event.kbd_id = 42;
+	ui_wdecor_kbd_event(wdecor, &event);
+
+	PCUT_ASSERT_TRUE(resp.sysmenu_right);
+	PCUT_ASSERT_INT_EQUALS(event.kbd_id, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Character key with active sysmenu handle generates sysmenu accel event */
+PCUT_TEST(kbd_accel_sysmenu)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	kbd_event_t event;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	test_cb_resp_t resp;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 100;
+	rect.p1.y = 200;
+
+	ui_wdecor_set_rect(wdecor, &rect);
+
+	ui_wdecor_set_cb(wdecor, &test_wdecor_cb, (void *) &resp);
+
+	ui_wdecor_sysmenu_hdl_set_active(wdecor, true);
+
+	resp.sysmenu_accel = false;
+
+	event.type = KEY_PRESS;
+	event.mods = 0;
+	event.key = KC_A;
+	event.c = 'a';
+	event.kbd_id = 42;
+	ui_wdecor_kbd_event(wdecor, &event);
+
+	PCUT_ASSERT_TRUE(resp.sysmenu_accel);
+	PCUT_ASSERT_INT_EQUALS(event.c, resp.accel);
+	PCUT_ASSERT_INT_EQUALS(event.kbd_id, resp.idev_id);
+
+	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_wdecor_get_geom() with ui_wds_none produces the correct geometry */
+PCUT_TEST(get_geom_none)
+{
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+	gfx_rect_t rect;
+	ui_wdecor_geom_t geom;
+	errno_t rc;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 100;
+	rect.p1.y = 200;
+
+	ui_wdecor_set_rect(wdecor, &rect);
 	ui_wdecor_get_geom(wdecor, &geom);
 
@@ -447,4 +1050,24 @@
 	PCUT_ASSERT_INT_EQUALS(0, geom.title_bar_rect.p1.y);
 
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.y);
+
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.x);
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.y);
@@ -504,4 +1127,24 @@
 	PCUT_ASSERT_INT_EQUALS(0, geom.title_bar_rect.p1.y);
 
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.caption_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.y);
+
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.x);
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.y);
@@ -562,4 +1205,24 @@
 	PCUT_ASSERT_INT_EQUALS(46, geom.title_bar_rect.p1.y);
 
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.sysmenu_hdl_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(18, geom.caption_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(24, geom.caption_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(91, geom.caption_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(46, geom.caption_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_min_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.y);
+
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.x);
 	PCUT_ASSERT_INT_EQUALS(0, geom.btn_close_rect.p0.y);
@@ -619,4 +1282,25 @@
 	PCUT_ASSERT_INT_EQUALS(46, geom.title_bar_rect.p1.y);
 
+	PCUT_ASSERT_INT_EQUALS(15, geom.sysmenu_hdl_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(25, geom.sysmenu_hdl_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(35, geom.sysmenu_hdl_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(45, geom.sysmenu_hdl_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(38, geom.caption_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(24, geom.caption_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(51, geom.caption_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(46, geom.caption_rect.p1.y);
+
+	PCUT_ASSERT_INT_EQUALS(55, geom.btn_min_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(25, geom.btn_min_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(75, geom.btn_min_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(45, geom.btn_min_rect.p1.y);
+
+	/* Maximize button is not in ui_wds_decorated */
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(0, geom.btn_max_rect.p1.y);
+
 	PCUT_ASSERT_INT_EQUALS(75, geom.btn_close_rect.p0.x);
 	PCUT_ASSERT_INT_EQUALS(25, geom.btn_close_rect.p0.y);
@@ -639,6 +1323,11 @@
 PCUT_TEST(rect_from_app)
 {
+	errno_t rc;
+	ui_t *ui = NULL;
 	gfx_rect_t arect;
 	gfx_rect_t rect;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
 	arect.p0.x = 14;
@@ -647,5 +1336,5 @@
 	arect.p1.y = 196;
 
-	ui_wdecor_rect_from_app(ui_wds_none, &arect, &rect);
+	ui_wdecor_rect_from_app(ui, ui_wds_none, &arect, &rect);
 
 	PCUT_ASSERT_INT_EQUALS(14, rect.p0.x);
@@ -654,5 +1343,5 @@
 	PCUT_ASSERT_INT_EQUALS(196, rect.p1.y);
 
-	ui_wdecor_rect_from_app(ui_wds_frame, &arect, &rect);
+	ui_wdecor_rect_from_app(ui, ui_wds_frame, &arect, &rect);
 
 	PCUT_ASSERT_INT_EQUALS(10, rect.p0.x);
@@ -661,5 +1350,5 @@
 	PCUT_ASSERT_INT_EQUALS(200, rect.p1.y);
 
-	ui_wdecor_rect_from_app(ui_wds_decorated, &arect, &rect);
+	ui_wdecor_rect_from_app(ui, ui_wds_decorated, &arect, &rect);
 
 	PCUT_ASSERT_INT_EQUALS(10, rect.p0.x);
@@ -668,4 +1357,5 @@
 	PCUT_ASSERT_INT_EQUALS(200, rect.p1.y);
 
+	ui_destroy(ui);
 }
 
@@ -673,4 +1363,7 @@
 PCUT_TEST(get_rsztype)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -679,5 +1372,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_resizable, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_resizable, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -759,5 +1460,5 @@
 	/* Non-resizable window */
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -775,4 +1476,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -803,4 +1508,7 @@
 PCUT_TEST(frame_pos_event)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -809,5 +1517,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_resizable, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_resizable, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -845,4 +1561,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -936,4 +1656,62 @@
 }
 
+static void test_wdecor_sysmenu_open(ui_wdecor_t *wdecor, void *arg,
+    sysarg_t idev_id)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->sysmenu_open = true;
+	resp->idev_id = idev_id;
+}
+
+static void test_wdecor_sysmenu_left(ui_wdecor_t *wdecor, void *arg,
+    sysarg_t idev_id)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->sysmenu_left = true;
+	resp->idev_id = idev_id;
+}
+
+static void test_wdecor_sysmenu_right(ui_wdecor_t *wdecor, void *arg,
+    sysarg_t idev_id)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->sysmenu_right = true;
+	resp->idev_id = idev_id;
+}
+
+static void test_wdecor_sysmenu_accel(ui_wdecor_t *wdecor, void *arg,
+    char32_t accel, sysarg_t idev_id)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->sysmenu_accel = true;
+	resp->accel = accel;
+	resp->idev_id = idev_id;
+}
+
+static void test_wdecor_minimize(ui_wdecor_t *wdecor, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->minimize = true;
+}
+
+static void test_wdecor_maximize(ui_wdecor_t *wdecor, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->maximize = true;
+}
+
+static void test_wdecor_unmaximize(ui_wdecor_t *wdecor, void *arg)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->unmaximize = true;
+}
+
 static void test_wdecor_close(ui_wdecor_t *wdecor, void *arg)
 {
@@ -943,5 +1721,6 @@
 }
 
-static void test_wdecor_move(ui_wdecor_t *wdecor, void *arg, gfx_coord2_t *pos)
+static void test_wdecor_move(ui_wdecor_t *wdecor, void *arg, gfx_coord2_t *pos,
+    sysarg_t pos_id)
 {
 	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
@@ -949,8 +1728,9 @@
 	resp->move = true;
 	resp->pos = *pos;
+	resp->pos_id = pos_id;
 }
 
 static void test_wdecor_resize(ui_wdecor_t *wdecor, void *arg,
-    ui_wdecor_rsztype_t rsztype, gfx_coord2_t *pos)
+    ui_wdecor_rsztype_t rsztype, gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
@@ -959,4 +1739,5 @@
 	resp->rsztype = rsztype;
 	resp->pos = *pos;
+	resp->pos_id = pos_id;
 }
 
